SystemOrganization addCategory: #OLE!
SystemOrganization addCategory: #'OLE-EToys'!

!Project methodsFor: '*ole' stamp: 'lg 10/13/2007 09:05'!
exit
	"Leave the current project and return to the project in which this one was created."

	self isTopProject ifTrue: [^ self beep: 'click' ].
	parentProject enter: false revert: false saveForRevert: false.
! !

Object subclass: #AnimalKingdom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

!OLE class methodsFor: 'childproofing' stamp: 'lg 10/31/2007 10:56'!
authorMode
	authorMode := true.
	self halosEnabled: true.
	Preferences disable: #eToyFriendly; enable: #warnIfNoSourcesFile; enable: #warnIfNoChangesFile.
	World selectKind: SugarNavigatorBar do: [ :m | m removeAllMorphs; addButtons ].! !

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

!OLE class methodsFor: 'sound effects' stamp: 'lg 11/6/2007 13:41'!
halosEnabled
	^halosEnabled ~= false.! !

!OLE class methodsFor: 'sound effects' stamp: 'lg 10/13/2007 06:44'!
halosEnabled: flag
	halosEnabled := flag.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 10/31/2007 10:58'!
isAuthorMode
	^authorMode = true.! !

!OLE class methodsFor: 'image' stamp: 'lg 10/14/2007 09:49'!
saveSoon
	[(Delay forSeconds: 10) wait. SmalltalkImage current saveSession] fork.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 10/17/2007 10:09'!
userMode
	self halosEnabled: false.
	Preferences enable: #eToyFriendly; disable: #warnIfNoSourcesFile; disable: #warnIfNoChangesFile.! !

!SequenceableCollection methodsFor: '*ole-removing' stamp: 'lg 11/1/2007 08:38'!
without: element
	^self select: [ :o | o ~= element ].! !

TextMorph subclass: #GameLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameLevel methodsFor: 'as yet unclassified' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^true! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

GameTextMorph subclass: #ScoreTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

ScoreTextMorph subclass: #MistakesTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameMistakes
	^true! !

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameScore
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:37'!
isGameInput
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:52'!
isGameScore
	^true! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:36'!
gameValue
	^self getCharacters asNumber.! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:33'!
gameValue: value
	self contents: value asString.! !

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum minSum haveMadeMistake score total level difficulty lastAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

NumberGame subclass: #MultiplyGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame class methodsFor: 'game' stamp: 'lg 10/12/2007 12:50'!
beginGame
	World allMorphsDo: [ :m | (m isKindOf: NumberGame) ifTrue: [m beginGame] ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:42'!
answer: n
	lastAnswer := n.
	n = self getGameValue ifTrue: [self win: n] ifFalse: [self lose].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 18:14'!
beginGame
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m resetObjectSequence]].
	self setLevel: 1.
	self setScore: 0.
	World selectMorphs: #isGameChoice do: #show.
	self setTotal: -1. "XXX cheesy"
	self newGame.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:10'!
chooseObject
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m installNewTallyMorph ]].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:38'!
difficulty: d
	difficulty := d.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:34'!
displayAnswer: n
	[ World selectKind: AnswerViewMorph do: [ :m | m contents: n asString. m show. (Delay forSeconds: 2) wait ]] fork.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/17/2007 17:37'!
displayMood: mood
	"["GameFeedbackMorph showState: mood.
	 (mood = #happy) ifTrue: [World selectKind: AnswerViewMorph do: [:m | m contents: lastAnswer asString; show]].
	World doOneCycleNow.
"	 (Delay forSeconds: 2) wait."
	 GameFeedbackMorph showState: #neutral.
	 World selectKind: AnswerViewMorph do: #hide
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:19'!
endGame
	self beep: 'byebye'.
	World selectMorphs: #isGameChoice do: #hide.
	World selectMorphs: #isGameInput do: [ :m | m setGameValue: 0 ].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:33'!
gameChoices
	^World allMorphs select: #isGameChoice.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/8/2007 17:06'!
increaseInputs
	| used seed |
	used := minValue * self gameInputs size.
	seed := ((minSum to: maxSum) - used) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/9/2007 09:07'!
initialize
	super initialize.
	self beginGame.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:45'!
lose
	self beep: 'wrong3'. self displayMood: #sad; mistake.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 14:03'!
mistake
	haveMadeMistake := true.
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 14:02'!
newGame
	haveMadeMistake := false.
	self setTotal: total + 1; resetInputs; increaseInputs; updateChoices.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
score
	self setScore: score + 1.
	(score \\ 10) = 0 ifTrue: [self setLevel: 1 + (score / 10)].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:33'!
setLevel: n
	level := n.
	World selectMorphs: #isGameLevel do: [:morph | morph contents: level asString].
	self chooseObject.
	difficulty = #easy
		ifTrue:
		[n = 1 ifTrue: [minValue := 1. minSum :=2. maxSum := 4].
		 n = 2 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 3 ifTrue: [minValue := 1. minSum := 2. maxSum := 8].
		 n = 4 ifTrue: [minValue := 0. minSum := 2. maxSum := 9].
		 n > 4 ifTrue: [self endGame] ]
		ifFalse:
		[n = 1 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 2 ifTrue: [minValue := 0. minSum := 0. maxSum := 9].
		 n = 3 ifTrue: [minValue := 0. minSum := 9. maxSum := 15].
		 n = 4 ifTrue: [minValue := 0. minSum := 12. maxSum := 20].
		 n > 4 ifTrue: [self endGame] ].

! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
setScore: n
	score := n.
	World selectMorphs: #isGameScore do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 13:52'!
setTotal: n
	total := n.
	World selectMorphs: #isGameTotal do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/2/2007 15:33'!
updateChoices
	| choices correct answers results stream |
	choices := self gameChoices.
	correct := self getGameValue.
	answers := (minValue to: maxSum) asArray shuffled reject: [ :x | x == correct]. 
	stream := answers readStream.
	results := OrderedCollection new.
	(choices size - 1) timesRepeat: [ results add: stream next ].
	results add: correct.
	results := results shuffled.
	stream := results readStream.
	choices do: [ :choice | choice setGameValue: stream next ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:57'!
win: n
	((n < 22) or: [n = 77]) ifTrue: [self beep: n asString] ifFalse: [self beep: 'right1'].
	self displayAnswer: n.
	haveMadeMistake ifFalse: [self score].
	self displayMood: #happy.
	self newGame.
! !

NumberGame subclass: #QuestionNumberGame
	instanceVariableNames: 'questions question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionNumberGame class methodsFor: 'game' stamp: 'lg 10/14/2007 16:01'!
readQuestion
	World selectKind: self do: #readQuestion.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:00'!
answer
	^question valueOfProperty: #answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:19'!
beginGame
	questions := (World allMorphs detect: [ :m | m isKindOf: QuestionSetMorph ]) questions.
	super beginGame.
! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:04'!
getGameValue
	^self answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 17:59'!
newGame
	total := total + 1.
	question ifNotNil: [question delete].
	questions atEnd ifTrue: [ ^self endGame ].
	question := questions next.
	World addMorph: question.
	question position: 75@125.
	question lock.
	haveMadeMistake := false.
	self setupChoicesForQuestion.! !

!QuestionNumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 16:04'!
readQuestion
	self beep: (question valueOfProperty: #questionSound).! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 10:32'!
setupChoicesForQuestion
	| choices answers rightAnswer |
	choices := self gameChoices shuffled readStream.
	choices atEnd ifTrue: [^self].
	rightAnswer := question valueOfProperty: #answer.
	answers := ((rightAnswer // 2 to: rightAnswer * 2) asOrderedCollection remove: rightAnswer; yourself) shuffled readStream.
	choices next setGameValue: rightAnswer.
	[choices atEnd] whileFalse: [ choices next setGameValue: answers next ].! !

Thumbnail subclass: #PicturePuzzleThumbnailMorph
	instanceVariableNames: 'puzzlePictureForm gridSize labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PicturePuzzleThumbnailMorph subclass: #PicturePuzzleFileThumbnailMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 09:24'!
initialize
	super initialize.
	self maxWidth: 200 minHeight: 150.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:09'!
labels: type
	labels := type.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:38'!
makeThumbnailFromForm: form
	puzzlePictureForm := form.
	^super makeThumbnailFromForm: form.! !

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 18:34'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new showSketch: (SketchMorph withForm: puzzlePictureForm).
	morph center: World center.
	morph top: 90.
	morph rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph rescramble.
	morph openInWorld.! !

Morph subclass: #GameFeedbackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameFeedbackMorph class methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 18:00'!
showState: state
	| class |
	class := state caseOf: { [#happy]   -> [GameHappyMorph].
						 [#neutral] -> [GameNeutralMorph].
						 [#sad]       -> [GameSadMorph] }.
	World selectKind: self do: [ :m | (m isKindOf: class) ifTrue: [m show] ifFalse: [m hide] ].
! !

GameFeedbackMorph subclass: #GameHappyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameNeutralMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameSadMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlighterMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlightMorph
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:19'!
handlesMouseDown: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:23'!
handlesMouseOver: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 11:04'!
mouseDown: event
	self color: Color transparent.
	self beep: 'click'.
	project enter! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseEnter: event
	self color: (Color yellow alpha: 0.3).! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseLeave: event
	self color: Color transparent.! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 11/1/2007 10:36'!
additionsToViewerCategoryGameInstrument
	(World allMorphs select: [ :m | m isKindOf: AddingGameMorph]) ifEmpty: [^ #() ].
	^#( #'game instrument'
			( (slot gameInstrumentType 'The type of game instrument.' GameInstrumentType readWrite Player getGameInstrumentType Player setGameInstrumentType:)
"			  (slot gameValue 'The numeric value' Number readWrite Player getGameValue Player setGameValue:)" )
		)! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/29/2007 14:46'!
supportsGameValue
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/30/2007 12:44'!
addGameItemsTo: aMenu hand: aHandMorph
"	aMenu add: 'OLE game...' translated subMenu:  (self buildGameMenu: aHandMorph)"! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/28/2007 09:50'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu add: 'rip off' translated action: #ripoff.
		aMenu addLine].

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	Preferences eToyFriendly ifFalse: [self addHaloActionsTo: aMenu].
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	Preferences eToyFriendly ifFalse: [self addCopyItemsTo: aMenu].
	self addPlayerItemsTo: aMenu.
	Preferences eToyFriendly ifFalse: [self addExportMenuItems: aMenu hand: aHandMorph].
	Preferences eToyFriendly ifFalse: [self addStackItemsTo: aMenu].
	self addMiscExtrasTo: aMenu.
	Preferences eToyFriendly ifFalse: [Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph]].
	self addGameItemsTo: aMenu hand: aHandMorph.

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: {unlockables first externalName})
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameChoiceString
	^ (self gameInstrumentType = #choice) yesNoString , 'be game choice'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameInputString
	^ (self gameInstrumentType = #input) yesNoString , 'be game input'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
buildGameMenu: aHand
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	self hasGameValue ifTrue:
		[aMenu addUpdating: #beGameInputString target: self selector: #toggleGameInstrumentType: argumentList: { #gameInput }.
		 aMenu addUpdating: #beGameChoiceString target: self selector: #toggleGameInstrumentType: argumentList: { #gameChoice } ].
	^ aMenu! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole-bugfix' stamp: 'lg 10/2/2007 15:44'!
fixYourLayout
	| realExtent |
	realExtent := self extent.
	self extent: 10@10.
	self extent: realExtent.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameChoices
	^self gameInstrumentsOfType: #choice.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameInputs
	^self gameInstrumentsOfType: #input.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameInstrumentsOfType: type
	^self allMorphs select: [ :m | (m valueOfProperty: #gameInstrumentType) = type ].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType
	^(self valueOfProperty: #gameInstrumentType) ifNil: [#none].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType: type
	self setProperty: #gameInstrumentType toValue: type.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/10/2007 10:33'!
grab
	self center: World activeHand center.
	World activeHand grabMorph: self.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 11:36'!
hasGameValue
	^false.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 10:06'!
highlightOnMouseOver
	| morph |
	morph := SimpleHighlightMorph new beSticky; extent: self extent; position: self position.
	self addMorph:morph.! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 15:10'!
isGameChoice
	^false! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
isGameInput
	^self gameInstrumentType = #gameInput.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/3/2007 12:46'!
isGameMistakes
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 16:51'!
isGameScore
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 14:03'!
isGameTotal
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 10/12/2007 17:46'!
selectKind: class do: aBlock 
	self allMorphsDo: [ :morph | (morph isKindOf: class) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*ole' stamp: 'lg 10/3/2007 12:45'!
selectMorphs: test do: aBlock 
	self allMorphsDo: [ :morph | (test value: morph) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:41'!
showAnimal
           World addMorph: self.
           self position: 200@200! !

!Morph methodsFor: '*ole' stamp: 'lg 10/11/2007 13:06'!
spreadMorphs
	| morph stream blockWidth blockHeight spareWidth spareHeight objectWidth objectHeight columns rows |
	self submorphs isEmpty ifTrue: [^self].
	columns := self submorphs size sqrt roundedUp.
	rows := (self submorphs size / columns) roundedUp.
	blockWidth := self width / columns.
	blockHeight := self height / rows.
	objectWidth := self submorphs first width.
	objectHeight := self submorphs first height.
	spareWidth := blockWidth - objectWidth max: 0.
	spareHeight := blockHeight - objectHeight max: 0.
	stream := self submorphs readStream.
	(0 to: rows-1) do: [:row | (0 to: columns-1) do: [:col |
		morph := stream next.
		morph ifNotNil: [morph position: self position + ((col * blockWidth + (0 to: spareWidth) atRandom) @ (row * blockHeight + (0 to: spareHeight) atRandom))]
	]]! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 14:52'!
supportsGameValue
	^self class supportsGameValue.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
toggleGameInstrumentType: type
	| newType |
	newType := self gameInstrumentType = type ifTrue: [nil] ifFalse: [type].
	self gameInstrumentType: newType.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/30/2007 17:26'!
waitForSeconds: n 
	World doOneCycle.
	(Delay forSeconds: n) wait.! !

!Morph methodsFor: '*ole-halo' stamp: 'lg 10/13/2007 06:47'!
wantsHaloFromClick

	^ self valueOfProperty: #wantsHaloFromClick ifAbsent: [^OLE halosEnabled].! !

Morph subclass: #PicturePuzzleMorph
	instanceVariableNames: 'labels rows columns realImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:30'!
checkCompletion
	(submorphs allSatisfy: #hasRightPiece) ifTrue: [self completed].! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:16'!
columns: c
	columns := c.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:27'!
completed
	self showSketch.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 13:02'!
initialize
	super initialize.
	rows := 6.
	columns := 6.
	labels := #().
	self beSticky.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:02'!
labels: collection
	labels := collection.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:21'!
placeInEmptyBox: morph
	| empty |
	empty := submorphs detect: [ :m | (m isKindOf: PicturePuzzleBlockMorph) and: [m submorphs isEmpty] ].
	empty addMorph: morph.
! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:17'!
rescramble
	self scrambleForm: realImageForm.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:38'!
rows: r
	rows := r.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 19:02'!
scrambleForm: form
	| letters tileWidth tileHeight morph sketch interior |
	self removeAllMorphs.
	letters := labels readStream.
	realImageForm := form.
	self extent: form extent.
	tileWidth := form width / columns.
	tileHeight := form height / rows.
 	(0 to: rows-1) do: [ :row | (0 to: columns-1) do: [ :col |
		morph := PicturePuzzleBlockMorph new.
		interior := (((row ~= 0) and: [row ~= (rows-1)]) and: [(col ~= 0) and: [col ~= (columns-1)]]).
		morph isInteriorBlock:interior.
		morph position: self position + ((col * tileWidth) @ (row * tileHeight)).
		morph extent: tileWidth @ tileHeight.
		morph layoutPolicy: TableLayout new.
		morph enableDrop: true.
		morph enableDrag: true.
		morph setProperty: #puzzlePosition toValue: row@col.
		self addMorph: morph.
		sketch := PicturePuzzlePieceMorph withForm: (form copy: (((col*tileWidth) @ (row*tileHeight)) extent: tileWidth@tileHeight)).
		sketch position: morph position.
		sketch setProperty: #puzzlePosition toValue: row@col.
		morph addMorph: sketch.
"		interior ifFalse: [sketch beSticky]."
		"Maybe label the morph"
		letters atEnd ifFalse: [sketch label: letters next].
	]].
	self shufflePieces.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:28'!
showSketch
	self showSketch: (SketchMorph withForm: realImageForm).
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:32'!
showSketch: sketch
	realImageForm := sketch form.
	sketch position: self position.
	self extent: sketch extent.
	self removeAllMorphs; addMorph: sketch.
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:25'!
shufflePieces
	| blocks pieces stream |
	blocks := self submorphs select: #isInteriorBlock.
	pieces := blocks collect: [ :block | block submorphs first ].
	stream := pieces shuffled readStream.
	blocks do: [ :block | block removeAllMorphs; addMorph: stream next ].
! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

Morph subclass: #SimpleHighlightMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:40'!
handlesMouseOver: event
	^true! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:07'!
initialize
	super initialize.
	self color: Color transparent.! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:08'!
mouseEnter: event
	^self color: (Color yellow alpha: 0.25).! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:41'!
mouseLeave: event
	^self color: Color transparent.! !

!SampledSound class methodsFor: '*ole' stamp: 'lg 10/13/2007 21:02'!
addLibrarySoundsFromWaveDirectory: directory
	| files snd |
	files := (FileDirectory on: directory) fileNamesMatching: '*.wav'.
	files do: [ :file |
		snd := SampledSound fromWaveFileNamed: directory, '/', file.
		SampledSound addLibrarySoundNamed: (file copyUpTo: $.) samples: snd samples samplingRate: snd originalSamplingRate ].! !

StringMorph subclass: #AddingGameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 10:28'!
additionsToViewerCategoryAddingGame
	^#( #'adding game' (
			(command setupNewQuestion 'Put a new problem on the screen')
		))! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:29'!
authoringPrototype
	^super authoringPrototype contents: '+'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 11:50'!
descriptionForPartsBin
	^ self partName: 'AddingGame' categories: {'OLE'} documentation: 'Adding game quiz generator'! !

!AddingGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:47'!
initializeToStandAlone
	super initializeToStandAlone.
	self contents: '+'; fontName: 'BitstreamVeraSans' size: 100.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/1/2007 11:43'!
setupNewProblem
	| choices inputs answer choiceValues |
	inputs := World gameInputs.
	choices := World gameChoices.
	inputs ifEmpty: [^self inform: 'You have to specify some inputs first'].
	choices ifEmpty: [^self inform: 'You have to specify some choices first'].
	inputs do: [ :choice | choice setGameValue: (1 to: 4) atRandom].
	answer := (inputs collect: #gameValue) sum.
	choiceValues := ( {answer} , ((2 to: 8) asArray shuffled without: answer) ) readStream.
	choices shuffled do: [ :input | input setGameValue: choiceValues next ].! !

!Player methodsFor: '*ole' stamp: 'lg 10/31/2007 15:56'!
getDifficultyLevel
	^costume valueOfProperty: #difficultyLevel ifAbsent: [1].! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
getGameInstrumentType
	^costume gameInstrumentType.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
getGameValue
	^costume gameValue! !

!Player methodsFor: '*ole' stamp: 'lg 10/31/2007 15:49'!
getTallyObject
	^costume valueOfProperty: #tallyObject ifAbsent: [ActiveWorld presenter standardPlayer].! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:46'!
sayNumber: n 
	self beep: n asString! !

!Player methodsFor: '*ole' stamp: 'lg 10/31/2007 15:53'!
setDifficultyLevel: n
	^costume setProperty: #difficultyLevel toValue: n.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
setGameInstrumentType: type
	costume gameInstrumentType: type.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
setGameValue: value
	costume gameValue: value! !

!Player methodsFor: '*ole' stamp: 'lg 10/31/2007 15:50'!
setTallyObject: morph
	^costume setProperty: #tallyObject toValue: morph.! !

!Player methodsFor: '*ole' stamp: 'lg 11/1/2007 10:33'!
setupNewQuestion
	costume setupNewProblem! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:28'!
waitForSeconds: n 
	costume waitForSeconds: n.! !

PasteUpMorph subclass: #ObjectSetMorph
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:33'!
initialize
	super initialize.
	self resetObjectSequence.! !

!ObjectSetMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 15:32'!
installNewTallyMorph
	| object |
	objects atEnd ifTrue: [^self].
	object := objects next.
	World allMorphsDo: [ :m | (m isKindOf: TallyMorph) ifTrue: [m setTallyObject: object] ].! !

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:31'!
resetObjectSequence
	objects := self submorphs readStream.! !

!PasteUpMorph class methodsFor: '*ole-scripting' stamp: 'lg 10/31/2007 16:07'!
additionsToViewerCategoryGameInstrument
	^ #().
! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:52'!
animalNames
	^self  submorphs collect:
	[:morph| morph externalName]! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:55'!
gameValue
	^self submorphs size! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 16:28'!
makeAnimalButton:label
	^AnimalButton new label:label.
! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 11/1/2007 08:36'!
setGameValue: n
	| object |
	object := self submorphs first.
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object duplicate ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 15:32'!
showAnimalNames
	|row|
	row:= AlignmentMorph inARow:
			(self animalNames collect:[:label| self makeAnimalButton:label]).
	row openInWorld; position: 200@600
       ! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject
	^self valueOfProperty: #tallyObject! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject: object
	^self setProperty: #tallyObject toValue: object! !

PasteUpMorph subclass: #PicturePuzzleBlockMorph
	instanceVariableNames: 'interiorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:43'!
hasRightPiece
	^self submorphs anySatisfy: [ :morph | (self valueOfProperty: #puzzlePosition) = (morph valueOfProperty: #puzzlePosition)].
 ! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:39'!
initialize
	super initialize.
	self color: World color.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:24'!
isInteriorBlock
	^interiorBlock.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:23'!
isInteriorBlock: flag 
	interiorBlock := flag.! !

PasteUpMorph subclass: #QuestionListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PasteUpMorph subclass: #QuestionSetMorph
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:20'!
questions
	^(self submorphs collect: #duplicate) readStream.! !

PasteUpMorph subclass: #TallyMorph
	instanceVariableNames: 'tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TallyMorph subclass: #TallyAnswerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
handlesMouseDown: event
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:38'!
isGameChoice
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:37'!
isGameInput
	^false! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:55'!
getGameValue
	^ (self submorphs select: [ :m | (m isKindOf: SimpleHighlightMorph) not]) size.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
increment
	self setGameValue: self getGameValue + 1! !

!TallyMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 12:22'!
initialize
	super initialize.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
isGameInput
	^ true! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:58'!
removeAllObjects
	self submorphs do: [ :m | (m isKindOf: SimpleHighlightMorph) ifFalse: [self removeMorph: m]].! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 12:02'!
setGameValue: n
	self removeAllObjects.
	n timesRepeat: [ self addMorph: tallyObject duplicate beSticky].
	self spreadMorphs.! !

!TallyMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 11:29'!
setTallyObject: object
	tallyObject := object.! !

!FileDirectory methodsFor: '*ole' stamp: 'lg 10/13/2007 20:18'!
importWaveSounds
	self shouldBeImplemented! !

SugarNavTab subclass: #OLESugarNavTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

ScriptableButton subclass: #AnimalButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AnimalButton methodsFor: 'as yet unclassified' stamp: 'ss 10/5/2007 16:34'!
doButtonAction
	AnimalGame answer:self label! !

ScriptableButton subclass: #GameButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:37'!
doButtonAction
	NumberGame answer: (self submorphs first contents asInteger)! !

!GameButton methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:34'!
isGameChoice
	^true! !

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:45'!
setGameValue: n 
	self submorphs first contents: n asString.
	self fixYourLayout.! !

!True methodsFor: '*ole' stamp: 'lg 10/29/2007 12:36'!
yesNoString
	^'<yes>'! !

SymbolListType subclass: #GameInstrumentType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-EToys'!

!GameInstrumentType methodsFor: 'initialization' stamp: 'lg 10/31/2007 16:00'!
initialize
	super initialize.
	self vocabularyName: #GameInstrumentType.
	symbols := #(none choice input).! !

!GameInstrumentType methodsFor: 'queries' stamp: 'lg 10/29/2007 14:06'!
representsAType
	^true.! !

!Symbol methodsFor: '*ole' stamp: 'jwl 10/1/2007 17:40'!
value: x 
	^ x perform: self.
! !

!False methodsFor: '*ole' stamp: 'lg 10/29/2007 12:35'!
yesNoString
	^'<no>'.! !

!Number methodsFor: '*ole' stamp: 'lg 10/11/2007 12:02'!
roundedUp
	^self = self asInteger ifTrue: [self asInteger] ifFalse: [self asInteger + 1].! !

EllipseMorph subclass: #EllipticGameInputMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:38'!
getGameValue
	^label contents asInteger.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:27'!
handlesMouseDown: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
handlesMouseOver: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:30'!
initialize
	super initialize.
	label := StringMorph new.
	label  contents: '0'; center: self center.
	self addMorph: label.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:34'!
isGameChoice
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:33'!
layoutChanged
	label center: self center.
	^super layoutChanged.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:39'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseEnter: event
	self color: (Color yellow alpha: 0.25).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseLeave: event
	self color: (Color transparent).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:35'!
setGameValue: n
	label contents: n asString.! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !

SketchMorph subclass: #PicturePuzzlePieceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 15:34'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	(morph isKindOf: PicturePuzzleBlockMorph) ifTrue:
		[ morph submorphs do: [ :m | morph owner placeInEmptyBox: m ] without: self ].
	self beep: 'click'.
	(morph owner isKindOf: PicturePuzzleMorph) ifTrue:
		[ morph owner checkCompletion ].! !

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 12:34'!
label: string 
	| morph font |
	font := string asInteger isNil ifTrue: [((TextStyle named: #BitstreamVeraSansMono) fontOfPointSize: 32)]
							  ifFalse: [((TextStyle named: #DevanagariNew) fontOfPointSize: 36)].
	morph := StringMorph contents: string font: font.
	morph shadowOffset: 2@2.
	morph center: self center.
	morph color: (Color white darker); hasDropShadow: true; shadowColor: (Color black alpha: 0.75).
	self addMorph: morph.! !

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:26'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add custom menu items"

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'restore base graphic' translated target: self action: #restoreBaseGraphicFromMenu.
	aCustomMenu add: 'call this my base graphic' translated target: self action: #callThisBaseGraphic.
	aCustomMenu add: 'choose new graphic...' translated target: self action: #chooseNewGraphic.
	aCustomMenu addLine.
	aCustomMenu add: 'set as background' translated target: rotatedForm action: #setAsBackground.
	self addPaintingItemsTo: aCustomMenu hand: aHandMorph.
	self addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:30'!
addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph
	aCustomMenu addLine.
	aCustomMenu add: 'create picture puzzle morph' translated
					target: self action: #grabPicturePuzzleMorph.
	aCustomMenu add: 'create picture puzzle thumbnail' translated
					target: self action: #grabPicturePuzzleThumbnailMorph.
! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:31'!
grabPicturePuzzleMorph
	| morph |
	morph := self picturePuzzleMorph openInWorld.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:34'!
grabPicturePuzzleThumbnailMorph
	self picturePuzzleThumbnailMorph openInWorld grab.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/9/2007 20:20'!
picturePuzzleMorph
	^PicturePuzzleMorph new scrambleForm: self form! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:31'!
picturePuzzleThumbnailMorph
	^PicturePuzzleThumbnailMorph new makeThumbnailFromForm: self form.! !

ImageMorph subclass: #PicturePuzzleThumbnailMorph2
	instanceVariableNames: 'filename gridSize cache labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph2 class methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:28'!
file: filename cache: flag
	^PicturePuzzleThumbnailMorph2 new setImageFile: filename cache: flag.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:05'!
initialize
	super initialize.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:08'!
loadFileIntoCache
	cache := (FileStream readOnlyFileNamed: filename) binary contents.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:10'!
loadForm
	^cache = nil ifTrue: [ImageReadWriter formFromFileNamed: filename] ifFalse: [ImageReadWriter formFromStream: cache readStream].! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:31'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph scrambleForm: self loadForm.
	morph center: World center.
	morph top: 90.
	morph openInWorld! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename cache: flag
	cache := nil.
	filename := aFilename.
	flag ifTrue: [self loadFileIntoCache].
	self showThumbnail.
! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename
	self setImageFile: aFilename cache: false.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:00'!
showThumbnail
	self image: (self loadForm scaledToSize: 200@150).
! !

SimpleButtonMorph subclass: #ScramblerMorph
	instanceVariableNames: 'gridSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:49'!
doButtonAction
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue:
								[ m rows: gridSize; columns: gridSize; rescramble ] ].! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
drawOn: canvas
	| c p r blockWidth blockHeight |
	blockWidth := self width // gridSize.
	blockHeight := self height // gridSize.
	(0 to: gridSize-1) do: [ :row | (0 to: gridSize-1) do: [ :col |
		c := row+col \\ 2 = 0 ifTrue: [color] ifFalse: [Color white].
		p := self position + ((blockWidth*col) @ (blockHeight*row)).
		r := p corner: p + (blockWidth@blockHeight).
		canvas fillRectangle: r color: c
	]]! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
initialize
	super initialize.
	self color: Color black.
	gridSize := 3.! !

!Integer methodsFor: '*ole-sound' stamp: 'lg 10/4/2007 12:24'!
sayInNepali
	self beep: 'ne-' , self asWords.! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 10/13/2007 12:49'!
balloonText
	^nil.
! !
